#include "otp.h"
#define log2of10 3.32192809488736234787


double
entropia(char *file)
{
  FILE *f;
  int i, oc;
  long ccount[256];	      /* Bins to count occurrences of values */
  long totalc = 0;	      /* Total character count */
  double ent=0.0;
  double prob[256];	   /* Probabilities per bin for entropy */

  if ((f = fopen(file,"r")) < 0)
    fatal("[] Error while open '%s' file: '%s'\n", file, strerror(errno));
  
  

  memset(ccount, 0, sizeof ccount);
  memset(prob, 0, sizeof prob);  
  while ((oc = fgetc(f)) != EOF) 
  {
	   unsigned char ocb;
	   ocb = (unsigned char) oc;
	   totalc ++;
	   ccount[ocb]++;	      /* Update counter for this bin */
  }  
  
  fclose(f);
  
  
  for (i = 0; i < 256; i++) 
	prob[i] = (double) ccount[i] / totalc;

  
  for (i = 0; i < 256; i++) 
	if (prob[i] > 0.0)
	  ent += prob[i] * (log2of10 *log10(1 / prob[i]));

    
  return ent/8*100;
}
