#include "otp.h"
int
otp_connect(char *host, unsigned short int port)
{
  struct sockaddr_in address;
  struct hostent *hp;
  int sock;

  if ((sock = socket(PF_INET, SOCK_STREAM, 0)) < 0)
    return -1;

  if ((hp = gethostbyname(host)) == NULL)
    return -1;

  memset(&address, 0, sizeof(address));
  memcpy((char *) &address.sin_addr, hp->h_addr, hp->h_length);
  address.sin_family = AF_INET;
  address.sin_port = htons((u_short) port);

  if ((connect(sock, (struct sockaddr *) &address, sizeof(address))) < 0)
    return -1;
  else
    return sock;
  return -1;
}



int
otp_server(unsigned short int port)
{
  int rsock, lsock;
  struct sockaddr_in server, client;
  unsigned int lclient;

  // ifconfig in qualke modo
  if ((rsock = socket(PF_INET, SOCK_STREAM, 0)) < 0)
    fatal("[] Error in socket()!\n");
  memset(&server, 0, sizeof(server)); /* Zero out structure */
  server.sin_family = AF_INET;  /* Internet address family */
  server.sin_addr.s_addr = htonl(INADDR_ANY); /* Any incoming interface */
  server.sin_port = htons(port); /* Local port */
  /*
   * Bind to the local address 
   */
  if (bind(rsock, (struct sockaddr *) &server, sizeof(server)) < 0)
    fatal("[] Errore in bind()!\n");
  if ((listen(rsock, 1)) < 0)
    fatal("[] Error in listen()!\n");
  /*
   * Set the size of the in-out parameter 
   */
  lclient = sizeof(client);
  /*
   * Wait for a client to connect 
   */
  if ((lsock = accept(rsock, (struct sockaddr *) &client, &lclient)) < 0)
    fatal("[] Error in accept()!\n");
  /*
   * clntSock is connected to a client! 
   */
  printf("[] Connected to client %s\n", inet_ntoa(client.sin_addr));
  return lsock;
}

int
otp_read(int sock, char *s, unsigned short int size)
{
  int i;

  if (timedrread(sock, 30))
  {
    i = read(sock, s, size);
    s[i] = 0;
    return i;
  } else
  {

    return -1;
  }
}


int
otp_write(int sock, const char *s)
{
  return write(sock, s, strlen(s));
}

void
otp_close(int sock)
{
  shutdown(sock, 2);
}



int
timedrselect(fd_set * rfds, int max, int time)
{
  struct timeval timeout;

  timeout.tv_sec = time;
  timeout.tv_usec = 0;

  if (select(max, rfds, NULL, NULL, &timeout) <= 0)
    return 1;
  return 0;
}

/*
 * prepare the socket to be read 
 */
int
timedrread(int sock, int time)
{
  fd_set rfds;

  FD_ZERO(&rfds);
  FD_SET(sock, &rfds);
  timedrselect(&rfds, sock + 1, time);
  return FD_ISSET(sock, &rfds);
}
