#include "otp.h"

// vpn with otp :D
int
initTun()
{
  int fdTun;
  char *tunDevName = "/dev/net/tun";
  struct ifreq ifr;
  int err;

  fdTun = open(tunDevName, O_RDWR | O_NONBLOCK);
  if (fdTun < 0)
    fatal("[] Error opening tun device '%s'.\n", tunDevName);

  ifr.ifr_flags = IFF_TUN;
  strncpy(ifr.ifr_name, "otp%d", 10);
  err = ioctl(fdTun, TUNSETIFF, (void *) &ifr);
  if (err < 0)
  {
    close(fdTun);
    fatal("[] Error with ioctl(TUNSETIFF).\n");
  }
  return fdTun;
}


void
main_loop()
{
  fd_set rfds;
  char buffer[1024];
  char c;
  int l, i = 0;

  // lseek to offset 
//  lseek(key_fd, offset, SEEK_SET);

  while (1)
  {
    FD_ZERO(&rfds);
    FD_SET(vpn_fd, &rfds);
    FD_SET(client_fd, &rfds);


    if (arg.debug)
      printf("[] Before select\n");
    select(FD_SETSIZE, &rfds, NULL, NULL, NULL);
    // i dati arrivano dall'interfaccia..li butto sul socket
    if (FD_ISSET(vpn_fd, &rfds))
    {
      l = read(vpn_fd, buffer, 1024);
      r_offset += l;
      buffer[l] = 0;
      if (!l)
        fatal("[] Interface closed!\n");
      if (arg.debug)
        printf("[] Reading %d bytes from interface: '%s'\n", l, buffer);

      // encrypt data
      for (i = 0; i < l; i++)
      {
        // read a byte from key_fd
        if (read(recv_fd, &c, (sizeof(char))) < 0)
          fatal("[] recv key is finish!\n");
        buffer[i] = buffer[i] ^ c;
      }

      l = write(client_fd, buffer, l);
      if (arg.debug)
        printf("[] Writing %d bytes to socket...\n", l);
    }
    // i dati arrivano dal socket...li butto sull'interfaccia
    if (FD_ISSET(client_fd, &rfds))
    {
      l = read(client_fd, buffer, 1024);
      if (!l)
        fatal("[] Connection closed!\n");
      if (arg.debug)
        printf("[] Reading %d bytes from socket..\n", l);
      // decrypt data
      for (i = 0; i < l; i++)
      {
        // read a byte from key_fd
        if (read(send_fd, &c, 1 * (sizeof(char))) < 0)
          fatal("[] key is finish!\n");
        buffer[i] = buffer[i] ^ c;
      }

      l = write(vpn_fd, buffer, l);
      if (arg.debug)
        printf("[] Writing %d to interface\n", l);
    }
  }
}
